// 
// 
// Copyright (C) 2005-2006 SIPez LLC.
// Licensed to SIPfoundry under a Contributor Agreement.
// 
// Copyright (C) 2004-2006 SIPfoundry Inc.
// Licensed by SIPfoundry under the LGPL license.
// 
// Copyright (C) 2004-2006 Pingtel Corp.
// Licensed to SIPfoundry under a Contributor Agreement.
// 
// $$
//////////////////////////////////////////////////////////////////////////////


#ifndef _OsDefs_h_
#define _OsDefs_h_

// SYSTEM INCLUDES
#ifdef _VXWORKS
#include "os/Vxw/OsVxwDefs.h"
#endif // _VXWORKS
#ifdef __pingtel_on_posix__
#include "os/linux/OsLinuxDefs.h"
#endif // __pingtel_on_posix__

// APPLICATION INCLUDES
// MACROS
// EXTERNAL FUNCTIONS
// DEFINES
#ifdef WIN32
#define snprintf _snprintf
#endif

#ifdef __cplusplus
extern "C" {
#endif

void enableConsoleOutput(int bEnable) ;
void osPrintf(const char* format , ...)
#ifdef __GNUC__
            // with the -Wformat switch, this enables format string checking
            __attribute__ ((format (printf, 1, 2)))
#endif
         ;
         
// A special value for "port number" which means that no port is specified.
#define PORT_NONE (-1)

// A special value for "port number" which means that some default port number
// should be used.  The default may be defined by the situation, or
// the OS may choose a port number.
// For use when PORT_NONE is used to mean "open no port", and in socket-opening
// calls.
#define PORT_DEFAULT (-2)

// Macro to test a port number for validity as a real port (and not PORT_NONE
// or PORT_DEFAULT).  Note that 0 is a valid port number for the protocol,
// but the Berkeley sockets interface makes it impossible to specify it.
// In addition, RTP treats port 0 as a special value.  Thus we forbid port 0.
#define portIsValid(p) ((p) >= 1 && (p) <= 65535)

// EXTERNAL VARIABLES
// CONSTANTS
// STRUCTS
// TYPEDEFS
// FORWARD DECLARATIONS

#ifdef __cplusplus
}
#endif



// standard definitions

#ifdef _64BIT_MACHINE_

// 64bit machine tricks

typedef unsigned long long int sipx_ulonglong_t;
typedef long long int sipx_longlong_t;
typedef unsigned long int sipx_ulong_t;
typedef long int sipx_long_t;
// we NEED this to be the size of (void *)
// this is a brutal (and hopefully transitional) solution
// that makes this thingie work on 64 bit platforms
typedef unsigned long int sipx_uint_t;
typedef long int sipx_int_t;
typedef unsigned short int sipx_ushort_t;
typedef short int sipx_short_t;

typedef unsigned long long int sipx_u64_t;
typedef long long int sipx_i64_t;
typedef unsigned int sipx_u32_t;
typedef int sipx_i32_t;
typedef unsigned short int sipx_u16_t;
typedef short int sipx_i16_t;

#else

// standard type defs

typedef unsigned long long int sipx_ulonglong_t;
typedef long long int sipx_longlong_t;
typedef unsigned long int sipx_ulong_t;
typedef long int sipx_long_t;
typedef unsigned int sipx_uint_t;
typedef int sipx_int_t;
typedef unsigned short int sipx_ushort_t;
typedef short int sipx_short_t;

typedef unsigned long long int sipx_u64_t;
typedef long long int sipx_i64_t;
typedef unsigned int sipx_u32_t;
typedef int sipx_i32_t;
typedef unsigned short int sipx_u16_t;
typedef short int sipx_i16_t;

#endif

#include "stdlib.h"
#include "string.h"
#include "stdio.h"
#include "time.h"

#endif  // _OsDefs_h_

