// 
// 
// Copyright (C) 2005-2006 SIPez LLC.
// Licensed to SIPfoundry under a Contributor Agreement.
// 
// Copyright (C) 2004-2006 SIPfoundry Inc.
// Licensed by SIPfoundry under the LGPL license.
// 
// Copyright (C) 2004-2006 Pingtel Corp.
// Licensed to SIPfoundry under a Contributor Agreement.
// 
// $$
//////////////////////////////////////////////////////////////////////////////

#ifndef QSTYPES__H__
#define QSTYPES__H__

#include "os/OsDefs.h"

/*-----------------------------------------------------------------------------
 * File: qsTypes.h
 * Module: STUN
 * Description:
 *  This file contains the declaration of the types that are used in the STUN
 *  module.
 *-----------------------------------------------------------------------------
 */

/*-----------------------------------------------------------------------------
 * Module history
 *
 * Date			Description
 * ----			-----------
 * 26 Feb 05		Initial version of the file
 *-----------------------------------------------------------------------------
 */

/*-----------------------------------------------------------------------------
 * Declarations and definitions:
 *  This section contains the local declarations and definitions of constants,
 *  macros, typdefs, etc.
 *-----------------------------------------------------------------------------
 */

/* 8 bit inttegers */
typedef char CHAR;
typedef unsigned char UCHAR;

/* 16 bit integers */
typedef sipx_i16_t SHORT;
typedef sipx_u16_t USHORT;

/* 32 bit integers */
typedef sipx_i32_t INT;
typedef sipx_u32_t UINT;

/* 64 bit integers; unsigned int is not defined since it is not likely needed */
typedef sipx_u64_t UINT64;
typedef sipx_i64_t INT64;

/* 128 bit integers; unsigned int is not defined since it is not likely needed */
typedef struct {
    unsigned char octet[16];
} UINT128;

#endif /* LOCALTYPES__H__ */
