Name: sipxportlib
Version: 3.5.0
Release: %{buildno}

Summary: OS Abstraction and OS Utilities library for sipX modules
License: LGPL
Group: Development/Libraries
Vendor: SIPfoundry
Packager: SIPfoundry <sipx-dev@sipfoundry.org>
Url: http://www.sipfoundry.org/sipXportLib

# sipXphone would require 0.9.7c to decrypt profiles to get access to
# certain new alg.  If this is still nec., this may need to be
# changed.  But in the meantime, Red Hat Enterprise 3.0 as of 08/16/04
# still uses 0.9.7a, so this is used. There's a HUGE implications of
# requiring RHEnterpise users to jeopardize their system by upgrading
# security package to a RH uncertified version.
Requires: openssl >= 0.9.7a
Requires: pcre >= 4.5
Requires: w3c-libwww >= 5.4.0

Source: %name-%version.tar.gz

Prefix: %_prefix
BuildRoot: %{_tmppath}/%name-%version-root

%description
This library provides a set of classes that provide an operating
system abstraction from a majority of OS provided functions. All of
the sipX projects use this library to ensure easy porting to any
operating system. The library currently provides classes that
encapsulate functions and operations for:

  * Threads
  * Locks and Mutexes
  * Semaphores
  * Messages and Queues
  * Timers
  * Time and Date
  * Sockets
  * File and Directory
  * Operating System Processes
  * Dynamic loading of shared libraries and symbols

# Install header files
%package devel
Requires: openssl-devel >= 0.9.7a
Requires: %name
Group: Development/Libraries
Vendor: SIPfoundry
Summary: Header files for %name 

%description devel
This library provides a set of classes that provide an operating
system abstraction from a majority of OS provided functions. All of
the sipX projects use this library to ensure easy porting to any
operating system. The library currently provides classes that
encapsulate functions and operations for:

  * Threads
  * Locks and Mutexes
  * Semaphores
  * Messages and Queues
  * Timers
  * Time and Date
  * Sockets
  * File and Directory
  * Operating System Processes
  * Dynamic loading of shared libraries and symbols

This package contains the neccessary header files and static libraries
helpful to build projects from the sipX library

%prep
%setup -q

%build
%configure --prefix=/usr/local/freeswitch --with-pcre=/usr/local/freeswitch --enable-sip-tls --enable-64bit
cp config.log %name.configlog
make all

%install

# makeinstall RPM macro doesn't leverage DESTDIR but instead overrides
# libdir, bindir, etc just for make install. This not copesetic w/how
# our makefiles are built, they'd rather preserve libdir, and use 
# DESTDIR when copying/moving/creating files.  The approach we're taking
# is quite standard, so it's surprising RPM's makeinstall macro is
# the way it is.
rm -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install

%clean
# Do Not Clean - when we are building a set of sipX RPMs, we need the 
#                dependencies to be here.
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc CONTRIBUTORS LICENSE INSTALL README NEWS TODO ChangeLog %name.configlog
%attr(755,root,root) %{_bindir}/syslogviewer
%attr(755,root,root) %{_bindir}/sipx-upgrade
%attr(755,root,root) %{_libdir}/libsipXport.la
%attr(755,root,root) %{_libdir}/libsipXport.so*
%attr(755,root,root) %{_bindir}/sipx-config
%attr(755,root,root) %{_bindir}/%name-config

%files devel
%defattr(644,root,root,755)
%doc doc/*
%doc %{_datadir}/doc/sipx/%name/*
%attr(755,root,root) %{_libdir}/libsipXunit.la
%attr(755,root,root) %{_libdir}/libsipXunit.a
%attr(755,root,root) %{_libdir}/libsipXport.a

%{_includedir}/os/*
%{_includedir}/utl/*
%{_includedir}/xmlparser/*
%{_includedir}/sipxunit/*
