#include <utl/UtlContainableTestStub.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

sipx_int_t UtlContainableTestStub::cCount = 0 ;

UtlContainableType UtlContainableTestStub::CONST_TYPE = "UtlContainableTestStub" ; 
UtlContainableTestStub::UtlContainableTestStub()
{
    cCount++ ;
    id = -1 ; 
}

UtlContainableTestStub::UtlContainableTestStub(sipx_int_t i)
{
    id = i ; 
    cCount++ ; 
}

UtlContainableTestStub :: ~UtlContainableTestStub()
{
    UtlContainableTestStub::cCount-- ;
}

void UtlContainableTestStub :: printCount()
{
    printf("Creation count = %d;\n", cCount) ;
}

UtlBoolean UtlContainableTestStub :: isEqual(const UtlContainable* c) const
{
    return (compareTo(c) == 0) ; 
}

sipx_uint_t UtlContainableTestStub :: hash() const
{
    return id ;
}

sipx_int_t UtlContainableTestStub :: compareTo(UtlContainable const* c) const
{
    sipx_int_t cmp = 1 ;
    if (c->getContainableType() == CONST_TYPE)
    {
        UtlContainableTestStub* t = (UtlContainableTestStub*)c ;
        sipx_int_t inId = t -> id ;
        cmp = id - inId ;
    }
    return cmp ;
}

UtlContainableType UtlContainableTestStub::getContainableType() const
{
    return CONST_TYPE;
}

sipx_int_t UtlContainableTestStub :: getCount()
{
    return cCount ;
}

void UtlContainableTestStub::clearCount()
{
    cCount = 0 ; 
}

UtlBoolean UtlContainableTestStub::isInstance(UtlContainable const* c) const 
{
    bool result = false ; 
    UtlContainableType cType = c -> getContainableType() ;
    result = (strcmp(cType, "UtlContainableTestStub") == 0) ;
    return result; 
}
