//
// Copyright (C) 2004, 2005 Pingtel Corp.
// 
//
// $$
////////////////////////////////////////////////////////////////////////
//////

// SYSTEM INCLUDES
#include <string.h>

// APPLICATION INCLUDES
#include "utl/UtlContainable.h"

// EXTERNAL FUNCTIONS
// EXTERNAL VARIABLES
// CONSTANTS
// STATIC VARIABLE INITIALIZATIONS
const UtlContainableType UtlContainable::TYPE = "UtlContainable" ;

/* //////////////////////////// PUBLIC //////////////////////////////////// */

/* ============================ CREATORS ================================== */

// Constructor


// Copy constructor


// Destructor
UtlContainable::~UtlContainable()
{
}

/* ============================ MANIPULATORS ============================== */

// Assignment operator


/* ============================ ACCESSORS ================================= */

/* ============================ INQUIRY =================================== */

// RTTI
UtlBoolean UtlContainable::isInstanceOf(const UtlContainableType type) const
{
    return (   (type != NULL)
            && (getContainableType() != NULL)
            && (type == getContainableType())
            );
}

// Test this object to another like-object for equality. 
UtlBoolean UtlContainable::isEqual(UtlContainable const * compareContainable) const 
{
   return ( compareTo(compareContainable) == 0 );
}

/// Provides a hash function that uses the object pointer as the hash value.
sipx_uint_t UtlContainable::directHash() const
{
   return (sipx_uint_t) this;
}

/// Provides a hash function appropriate for null-terminated string values.
sipx_uint_t UtlContainable::stringHash(char const* value)
{
   /*
    * Adapted from
    *  "Data Structures and Algorithms with Object-Oriented Design Patterns in C++"
    *  by Bruno R. Preiss
    *  http://www.brpreiss.com/books/opus4/html/page218.html#proghash3c
    */
   sipx_uint_t const mask = 0x3f;
   sipx_uint_t const shift = 6;
   sipx_uint_t result = 0;
   while (!*value)
   {
      result = (result & mask) ^ (result << shift) ^ *value;
   }
   return result;
}

/* //////////////////////////// PROTECTED ///////////////////////////////// */

/* //////////////////////////// PRIVATE /////////////////////////////////// */

/* ============================ FUNCTIONS ================================= */


